#ifndef _STCKBASE_HXX
#define _STCKBASE_HXX 1

/*
 *	stckbase.hxx
 *	ines foundation stack class
 */

/*
 *	StackBase
 *	Stack management on integer basis.
 *	MultiThreading and data management has to be implemented 
 *	by the derived class.
 */
class StackBase {
	/*
	 *	control pointers
	 */
	int	_iSp;			/* stack pointer (next push elem) */
	int	_cElMax;		/* max count of elemen  */
public:
	int 	stEmpty() { return (_iSp == 0); }
	int 	stAvail(int iOffs) { return (_iSp > iOffs); }	/* offs available ? */
	int 	stFull() { return (_cElMax == _iSp); }
	int 	iTos () { return _iSp-1; }
	int 	iTos (int iOffs) { return _iSp-iOffs-1; }
	int 	iBos (int iOffs) { return iOffs; }

	int 	cCur () { return _iSp;    }
	int 	cMax () { return _cElMax; }
	int 	cRem () { return _cElMax-_iSp; }

	/*
	 *	pop()
	 *	return index of element to be read,
	 *	and remove that element.
	 *	Stack must be (!stEmpty()), asserted.
	 *	fWasFull is set if the Stack was full.
	 */
	int 	iPop(int *_pfWasFull);
	int 	iPop();

	
	/*
	 *	push()
	 *	return index where new element can be
	 *	stored.
	 *	Stack must be (!stFull()), asserted;
	 *	fWasEmpty is set if the Stack was empty.
	 */
	int 	iPush(int *_pfWasEmpty);
	int 	iPush();

	/*
	 *	iterate :
	 *	BT - from bottom to top
	 *	iteration must be atomic.
	 */
	struct Iter { int _i; };
	void	strtIterBT(Iter *pit);
	int	iterBT(Iter*pit);	/* -1 for END		*/

	StackBase(int c); 		/* c must be at least 1	*/
	~StackBase();			/* clear()s before deletion */
};

#endif 
